﻿Imports Leap
Imports System.Windows.Ink



Class MainWindow
    Private Declare Function SetCursorPos Lib "user32" (x As Integer, y As Integer) As Boolean
    Private Declare Function apimouse_event Lib "user32" Alias "mouse_event" (ByVal dwFlags As Int32, ByVal dx As Int32, ByVal dy As Int32, ByVal cButtons As Int32, ByVal dwExtraInfo As Int32) As Boolean
    Private Const MOUSEEVENTF_LEFTDOWN = &H2
    Private Const MOUSEEVENTF_LEFTUP = &H4
    Private Const MOUSEEVENTF_MOVE = &H1
    Private leap As New Controller
    Private touchIndicator As New DrawingAttributes
    Private touchPoint As StylusPoint
    Private tx As Double
    Private ty As Double
    Private x As Integer
    Private y As Integer
    Private ImageX As Double
    Private ImageY As Double
    'Private Index As Integer
    Private windowWidth As Double = 1920
    Private windowHeight As Double = 1080
    'Private no As Integer
    Private FingersCount As Integer

   

    Private Sub MainWindow_Loaded(sender As Object, e As RoutedEventArgs) Handles Me.Loaded
        AddHandler CompositionTarget.Rendering, AddressOf Update
        touchIndicator.Width = 10
        touchIndicator.Height = 10

        touchIndicator.StylusTip = StylusTip.Ellipse

    End Sub

    Private Sub Update(sender As Object, e As EventArgs)
        paintCanvas.Strokes.Clear()
        windowWidth = Me.Width
        windowHeight = Me.Height

        Dim frame As Leap.Frame = leap.Frame
        Dim interactionBox As InteractionBox = leap.Frame.InteractionBox

        For Each Pointable As Pointable In leap.Frame.Pointables
            Dim normalizedPosition As Leap.Vector = interactionBox.NormalizePoint(Pointable.StabilizedTipPosition)

            tx = normalizedPosition.x * windowWidth
            ty = windowHeight - normalizedPosition.y * windowHeight

            touchPoint = New StylusPoint(tx, ty)

            Dim tips As New StylusPointCollection(New StylusPoint() {touchPoint})
            Dim touchStroke As New Stroke(tips, touchIndicator)
            paintCanvas.Strokes.Add(touchStroke)

            'ホーバー
            If Pointable.TouchDistance > 0 AndAlso Pointable.TouchZone <> Global.Leap.Pointable.Zone.ZONENONE Then
                touchIndicator.Color = Colors.Blue

                x = touchPoint.X
                y = touchPoint.Y
                FingersCount = leap.Frame.Fingers.Count
                apimouse_event(MOUSEEVENTF_LEFTUP, 0, 0, 0, 0)

                'タッチ
            ElseIf Pointable.TouchDistance <= 0 Then

                touchIndicator.Color = Colors.Red
                If FingersCount = 1 Then
                    SetCursorPos(touchPoint.X, touchPoint.Y)
                    apimouse_event(MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0)
                    apimouse_event(MOUSEEVENTF_MOVE, 0, 0, 0, 0)
                End If

                If FingersCount = 5 Then
                    zoomImage.Visibility = Windows.Visibility.Collapsed
                End If
                'タッチ対象外
            Else
                touchIndicator.Color = Colors.Gold
            End If
        Next
    End Sub

    Private Sub sourceImage_MouseLeftButtonDown(sender As Object, e As MouseButtonEventArgs) Handles sourceImage.MouseLeftButtonDown
        zoomImage.Visibility = Windows.Visibility.Visible
        ImageX = e.GetPosition(sourceImage).X
        ImageY = e.GetPosition(sourceImage).Y
        LensPosition(ImageX, ImageY)
    End Sub

    Private Sub sourceImage_MouseMove(sender As Object, e As MouseEventArgs) Handles sourceImage.MouseMove
        ImageX = e.GetPosition(sourceImage).X
        ImageY = e.GetPosition(sourceImage).Y
        LensPosition(ImageX, ImageY)
    End Sub

    Private Sub sourceImage_MouseLeftButtonUp(sender As Object, e As MouseButtonEventArgs) Handles sourceImage.MouseLeftButtonUp
        zoomImage.Visibility = Windows.Visibility.Collapsed
    End Sub



    Private Sub LensPosition(x As Double, y As Double)
        Lens.Center = New Point(ImageX, ImageY)
    End Sub



End Class
